%global branch 23.08
%global version 23.08.20
%global llvm_major 18
%global llvm_version 18.1.8

# Check for updates with:
#  flatpak remote-info --arch=x86_64 flathub org.freedesktop.Platform//23.08
#  flatpak remote-info --arch=x86_64 flathub org.freedesktop.Sdk//23.08
#  flatpak remote-info --arch=x86_64 flathub org.freedesktop.Sdk.Extension.llvm18//23.08

%ifarch aarch64
%global platform_commit 693e72fbe296fae7087c3533695c9f79144f5b442d3964dac1afed0ac70361a8
%global sdk_commit 15d7b0d5944b00ee2773c8e33cb2e58c4e843b7bbf5c80d0d7a81cb1c8ce4122
%global llvm_commit 72da52d1f552e891f087005dd79ef864811a5a06df566d6cd0e59947abf01651
%endif

%ifarch x86_64
%global platform_commit 1aeabe05e0b2e73715b44957ce19943117a0f4a9201c3612fe095da2333fe77b
%global sdk_commit 5292733d730c222c50e4e31a1496d30615f7d0787e4cc9518862d0dc46780d27
%global llvm_commit 5311e43c5398b2ce50a935c761693faf80d0079afb2232b9fbc00a1138215a38
%endif

Name:           fdo-sdk-%{branch}-flatpak
Summary:        Flatpak Freedesktop SDK
Version:        %{version}
Release:        1
License:        MIT AND Apache-2.0 WITH LLVM-exception
URL:            https://freedesktop-sdk.gitlab.io/

BuildRequires:  flatpak

BuildArch:      aarch64 x86_64 %{ix86}

%description
%{summary}.

%package -n fdo-runtime-%{branch}-flatpak
Summary:        Flatpak Freedesktop Runtime

%description -n fdo-runtime-%{branch}-flatpak
%{summary}.

%package -n fdo-sdk-extension-llvm%{llvm_major}-%{branch}-flatpak
Version:        %{llvm_version}
Summary:        Flatpak Freedesktop SDK llvm%{llvm_major} extension

%description -n fdo-sdk-extension-llvm%{llvm_major}-%{branch}-flatpak
%{summary}.

%prep
flatpak remote-add --user flathub https://dl.flathub.org/repo/flathub.flatpakrepo
flatpak remote-modify --user --collection-id=org.flathub.Stable flathub

%build
flatpak install --assumeyes --no-deps --no-related --user flathub org.freedesktop.Platform//%{branch}
flatpak update --assumeyes --no-deps --no-related --user --commit=%{platform_commit} org.freedesktop.Platform//%{branch}
flatpak install --assumeyes --no-deps --no-related --user flathub org.freedesktop.Sdk//%{branch}
flatpak update --assumeyes --no-deps --no-related --user --commit=%{sdk_commit} org.freedesktop.Sdk//%{branch}
flatpak install --assumeyes --no-deps --no-related --user flathub org.freedesktop.Sdk.Extension.llvm%{llvm_major}//%{branch}
flatpak update --assumeyes --no-deps --no-related --user --commit=%{llvm_commit} org.freedesktop.Sdk.Extension.llvm%{llvm_major}//%{branch}

%install
mkdir -p %{buildroot}%{_datadir}/flatpak-sideload/{fdo-sdk,fdo-runtime,fdo-sdk-extension-llvm%{llvm_major}}-%{branch}
flatpak create-usb --user %{buildroot}%{_datadir}/flatpak-sideload/fdo-sdk-%{branch} org.freedesktop.Sdk//%{branch}
flatpak create-usb --user %{buildroot}%{_datadir}/flatpak-sideload/fdo-runtime-%{branch} org.freedesktop.Platform//%{branch}
flatpak create-usb --user %{buildroot}%{_datadir}/flatpak-sideload/fdo-sdk-extension-llvm%{llvm_major}-%{branch} org.freedesktop.Sdk.Extension.llvm%{llvm_major}//%{branch}

%files
%{_datadir}/flatpak-sideload/fdo-sdk-%branch

%files -n fdo-runtime-%{branch}-flatpak
%{_datadir}/flatpak-sideload/fdo-runtime-%branch

%files -n fdo-sdk-extension-llvm%{llvm_major}-%{branch}-flatpak
%{_datadir}/flatpak-sideload/fdo-sdk-extension-llvm%{llvm_major}-%branch

%changelog
* Mon Jul 15 2024 Hector Martin <marcan@fedoraproject.org> - 23.08.20-1
- Initial release
